typedef union {
  unicode_string* text;
  deque<unicode_string>* stringList;
  unsigned long longNumber;   // also used for a single character, etc.
  unsigned long long doubleLong;
  float floatNumber;
  double doubleFloat;
  CJavaAccessFlags* modifiers;
  CJavaTypeSignature* typeSignature;
  CJavaFieldSignature* fieldSignature;
  deque<CJavaFieldSignature>* fieldList;
  CExpression* expression;
  ExpressionList* expressionList;
  deque<CVariableDeclaration*>* variableList;
  CStatement* statement;
  CCompoundStatement* compoundStatement;
  StatementList* statementList;
  deque<CCatchClause*>* catchList;
  CCatchClause* catchClause;
} YYSTYPE;
#define	ERROR	258
#define	ABSTRACT	259
#define	BOOLEAN	260
#define	BREAK	261
#define	BYTE	262
#define	CASE	263
#define	CATCH	264
#define	CHAR	265
#define	CLASS	266
#define	CONTINUE	267
#define	DEFAULT	268
#define	DO	269
#define	DOUBLE	270
#define	EXTENDS	271
#define	FALSE_TOKEN	272
#define	FINAL	273
#define	FINALLY	274
#define	FLOAT	275
#define	FOR	276
#define	IF	277
#define	IMPLEMENTS	278
#define	IMPORT	279
#define	INSTANCEOF	280
#define	INT	281
#define	INTERFACE	282
#define	LONG	283
#define	NATIVE	284
#define	NULL_TOKEN	285
#define	PACKAGE	286
#define	PRIVATE	287
#define	PROTECTED	288
#define	PUBLIC	289
#define	RETURN	290
#define	SHORT	291
#define	STATIC	292
#define	SUPER	293
#define	SWITCH	294
#define	SYNCHRONIZED	295
#define	THIS	296
#define	THROW	297
#define	THROWS	298
#define	TRANSIENT	299
#define	VOLATILE	300
#define	TRUE_TOKEN	301
#define	TRY	302
#define	VOID	303
#define	WHILE	304
#define	INT_LITERAL	305
#define	CHARACTER_LITERAL	306
#define	LONG_LITERAL	307
#define	FLOAT_LITERAL	308
#define	DOUBLE_LITERAL	309
#define	SYMBOL	310
#define	STRING_LITERAL	311
#define	NOT_AN_OPERATOR	312
#define	SHIFT_RIGHT_EQUALS	313
#define	FILL_SHIFT_RIGHT_EQUALS	314
#define	SHIFT_LEFT_EQUALS	315
#define	ADD_EQUALS	316
#define	SUB_EQUALS	317
#define	MUL_EQUALS	318
#define	DIV_EQUALS	319
#define	MOD_EQUALS	320
#define	AND_EQUALS	321
#define	XOR_EQUALS	322
#define	OR_EQUALS	323
#define	OR	324
#define	AND	325
#define	EQUAL_COMPARE	326
#define	NOT_EQUAL	327
#define	LTEQ	328
#define	GTEQ	329
#define	BITSHIFT_RIGHT	330
#define	FILL_SHIFT_RIGHT	331
#define	SHIFT_LEFT	332
#define	CAST	333
#define	INCR	334
#define	DECR	335
#define	UMINUS	336
#define	UPLUS	337
#define	POST_INCR	338
#define	POST_DECR	339
#define	NEW	340
#define	LOWER_THAN_ELSE	341
#define	ELSE	342


extern YYSTYPE yylval;
